package nemosofts.hd.wallpaper.activity;

import static android.Manifest.permission.READ_EXTERNAL_STORAGE;
import static android.Manifest.permission.READ_MEDIA_IMAGES;
import static android.Manifest.permission.WRITE_EXTERNAL_STORAGE;

import android.content.Intent;
import android.content.pm.PackageManager;
import android.content.res.ColorStateList;
import android.graphics.Bitmap;
import android.graphics.Color;
import android.graphics.drawable.Drawable;
import android.os.Build;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.ProgressBar;
import android.widget.RatingBar;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.widget.Toolbar;
import androidx.core.content.ContextCompat;
import androidx.nemosofts.AppCompat;
import androidx.nemosofts.AppCompatActivity;
import androidx.nemosofts.theme.ThemeEngine;
import androidx.palette.graphics.Palette;
import androidx.viewpager.widget.PagerAdapter;
import androidx.viewpager.widget.ViewPager;

import com.bumptech.glide.Glide;
import com.bumptech.glide.load.DataSource;
import com.bumptech.glide.load.engine.GlideException;
import com.bumptech.glide.load.resource.gif.GifDrawable;
import com.bumptech.glide.request.RequestListener;
import com.google.android.material.snackbar.Snackbar;
import com.like.LikeButton;
import com.like.OnLikeListener;
import com.ortiz.touchview.TouchImageView;
import com.squareup.picasso.Picasso;
import com.squareup.picasso.Target;

import org.greenrobot.eventbus.Subscribe;
import org.greenrobot.eventbus.ThreadMode;

import java.util.ArrayList;

import nemosofts.hd.wallpaper.R;
import nemosofts.hd.wallpaper.asyncTask.LoadStatus;
import nemosofts.hd.wallpaper.asyncTask.LoadUpdateTask;
import nemosofts.hd.wallpaper.asyncTask.LoadWallpaper;
import nemosofts.hd.wallpaper.callback.Callback;
import nemosofts.hd.wallpaper.dialog.FeedBackDialog;
import nemosofts.hd.wallpaper.dialog.ReviewDialog;
import nemosofts.hd.wallpaper.dialog.VerifyDialog;
import nemosofts.hd.wallpaper.interfaces.SuccessListener;
import nemosofts.hd.wallpaper.interfaces.UpdateListener;
import nemosofts.hd.wallpaper.interfaces.WallpaperListener;
import nemosofts.hd.wallpaper.item.ItemWallpaper;
import nemosofts.hd.wallpaper.utils.ApplicationUtil;
import nemosofts.hd.wallpaper.utils.EventAction;
import nemosofts.hd.wallpaper.utils.GlobalBus;
import nemosofts.hd.wallpaper.utils.IfSupported;
import nemosofts.hd.wallpaper.utils.SharedPref;
import nemosofts.hd.wallpaper.utils.helper.Helper;
import okhttp3.RequestBody;

public class GIFDetailsActivity extends AppCompatActivity {

    Helper helper;
    SharedPref sharedPref;
    int position = 0, pos_type = 0, page = 2;
    Boolean isOver = false, isLoading = true;

    ViewPager viewpager;
    ImagePagerAdapter pagerAdapter;
    ImageView iv_setAs, iv_download, iv_star, iv_share, iv_fav;
    TextView tv_views, tv_title, tv_resolution, tv_size, tv_type;
    TextView tv_share, tv_set, tv_downloads;
    RatingBar rating;
    LikeButton fav;
    RelativeLayout coordinatorLayout;
    final int MY_PERMISSIONS_REQUEST_WRITE_EXTERNAL_STORAGE = 102;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        IfSupported.IsRTL(this);
        IfSupported.IsScreenshot(this);

        Toolbar toolbar = findViewById(R.id.toolbar);
        getWindow().getDecorView().setSystemUiVisibility(View.SYSTEM_UI_FLAG_LAYOUT_STABLE | View.SYSTEM_UI_FLAG_LAYOUT_FULLSCREEN);
        getWindow().setStatusBarColor(Color.TRANSPARENT);
        RelativeLayout.LayoutParams params = new RelativeLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.WRAP_CONTENT);
        params.topMargin = 55;
        toolbar.setLayoutParams(params);

        toolbar.setTitle("");
        this.setSupportActionBar(toolbar);
        if (getSupportActionBar() != null) {
            getSupportActionBar().setDisplayHomeAsUpEnabled(true);
            getSupportActionBar().setDisplayShowHomeEnabled(true);
        }
        toolbar.setNavigationOnClickListener(view -> finish());

        helper = new Helper(this);
        sharedPref = new SharedPref(this);

        helper = new Helper(this, (pos, type) -> {
            if (is_save()){
                if (type.equals(getString(R.string.share))){
                    updateData(getString(R.string.share), viewpager.getCurrentItem());
                } else if (type.equals(getString(R.string.set_wallpaper))){
                    updateData(getString(R.string.set_wallpaper), viewpager.getCurrentItem());
                }
                helper.saveImage(Callback.arrayListLiveWallpapers.get(viewpager.getCurrentItem()).getImage(), type, coordinatorLayout, "live_wall");
            } else {
                Intent intentPlan = new Intent(this, BillingSubscribeActivity.class);
                intentPlan.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                startActivity(intentPlan);
            }
        });

        position = getIntent().getIntExtra("pos", 0);
        pos_type = getIntent().getIntExtra("pos_type", 0);
        page = getIntent().getIntExtra("page", 0);

        coordinatorLayout = findViewById(R.id.rl);
        tv_views = findViewById(R.id.tv_details_views);
        tv_title = findViewById(R.id.tv_details_cat);
        tv_resolution = findViewById(R.id.tv_details_resolution);
        tv_size = findViewById(R.id.tv_details_size);
        tv_type = findViewById(R.id.tv_details_type);
        rating = findViewById(R.id.rating_wall_details);
        fav = findViewById(R.id.details_fav);

        iv_setAs = findViewById(R.id.iv_setAs);
        iv_download = findViewById(R.id.iv_download);
        iv_star = findViewById(R.id.iv_star);
        iv_share = findViewById(R.id.iv_share);
        iv_fav = findViewById(R.id.iv_fav);

        tv_share = findViewById(R.id.tv_details_share);
        tv_set = findViewById(R.id.tv_details_set);
        tv_downloads = findViewById(R.id.tv_details_downloads);

        pagerAdapter = new ImagePagerAdapter();
        viewpager = findViewById(R.id.vp_wall_details);
        viewpager.setAdapter(pagerAdapter);
        viewpager.setCurrentItem(position);
        viewpager.addOnPageChangeListener(new ViewPager.OnPageChangeListener() {
            @Override
            public void onPageSelected(int pos) {
                position = viewpager.getCurrentItem();
                getData();
                updateData("view", position);

                if (Boolean.TRUE.equals(isLoading && page != 0 && !isOver) && position == Callback.arrayListLiveWallpapers.size() - 1) {
                    getLatestData();
                }
            }

            @Override
            public void onPageScrolled(int arg0, float arg1, int position) {
            }

            @Override
            public void onPageScrollStateChanged(int position) {
            }
        });

        getData();
        updateData("view", position);
        loadVibrantColor(position);

        if (sharedPref.isLogged()) {
            fav.setOnLikeListener(new OnLikeListener() {
                @Override
                public void liked(LikeButton likeButton) {
                    try {
                        loadFav();
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                }

                @Override
                public void unLiked(LikeButton likeButton) {
                    try {
                        loadFav();
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                }
            });
        } else {
            fav.setOnClickListener(view -> {
                if (!sharedPref.isLogged()) {
                    helper.clickLogin();
                }
            });
        }

        iv_setAs.setOnClickListener(v -> helper.showInterAd(0, getString(R.string.set_wallpaper)));
        iv_download.setOnClickListener(v -> helper.showInterAd(0, getString(R.string.download)));
        iv_share.setOnClickListener(v -> helper.showInterAd(0, getString(R.string.share)));
        iv_star.setOnClickListener(v -> showRateDialog());
    }

    private boolean is_save() {
        boolean is_save = false;
        if (Boolean.TRUE.equals(checkPer())){
            if (Callback.arrayListLiveWallpapers.get(viewpager.getCurrentItem()).isPremium()){
                if (Boolean.TRUE.equals(Callback.isPurchases)){
                    is_save = true;
                }
            } else {
                is_save = true;
            }
        }
        return is_save;
    }

    private void getLatestData() {
        if (helper.isNetworkAvailable()) {
            boolean is_update = false;
            RequestBody requestBody = null;
            if (pos_type == 0) {
                is_update = true;
                requestBody = helper.getAPIRequest(Callback.METHOD_LATEST_GIF, page, "", "", "", "", new SharedPref(this).getUserId(), "", "", "", "", "", "", "latest", null);
            } else if (pos_type == 1) {
                is_update = true;
                requestBody = helper.getAPIRequest(Callback.METHOD_LATEST_GIF, page, "", "", "", "", new SharedPref(this).getUserId(), "", "", "", "", "", "", "total_views", null);
            } else if (pos_type == 2) {
                is_update = true;
                requestBody = helper.getAPIRequest(Callback.METHOD_LATEST_GIF, page, "", "", "", "", new SharedPref(this).getUserId(), "", "", "", "", "", "", "total_rate", null);
            } else if (pos_type == 3) {
                is_update = true;
                requestBody = helper.getAPIRequest(Callback.METHOD_FAV_WALL, page, "", "", "", "", new SharedPref(this).getAuthID(), "", "", "", "", "", "", "gif", null);
            } else {
                showSnackBar(false, getString(R.string.err_no_data_found));
            }
            LoadWallpaper loadWallpaper = new LoadWallpaper(new WallpaperListener() {
                @Override
                public void onStart() {
                    isLoading = false;
                    findViewById(R.id.pb_load).setVisibility(View.VISIBLE);
                    showSnackBar(false, getResources().getString(R.string.loading));
                }

                @Override
                public void onEnd(String success, String verifyStatus, String message, ArrayList<ItemWallpaper> arrayListWall) {
                    if (success.equals("1")) {
                        if (!verifyStatus.equals("-1")) {
                            if (arrayListWall.isEmpty()) {
                                isOver = true;
                            } else {
                                page = page + 1;
                                Callback.arrayListLiveWallpapers.addAll(arrayListWall);
                                pagerAdapter.notifyDataSetChanged();
                                showSnackBar(true, getResources().getString(R.string.added));
                            }
                        } else {
                            new VerifyDialog(GIFDetailsActivity.this, getString(R.string.err_unauthorized_access), message);
                        }
                    }
                    isLoading = true;
                    findViewById(R.id.pb_load).setVisibility(View.GONE);
                }
            }, requestBody);
            if (is_update){
                loadWallpaper.execute();
            }
        } else {
            showSnackBar(false, getString(R.string.err_internet_not_connected));
        }
    }

    private void getData() {
        try {
            ItemWallpaper itemWallpaper = Callback.arrayListLiveWallpapers.get(viewpager.getCurrentItem());
            if (itemWallpaper != null){
                tv_views.setText(ApplicationUtil.format(Integer.parseInt(itemWallpaper.getTotalViews().isEmpty() ? "0" : itemWallpaper.getTotalViews())));
                tv_title.setText(itemWallpaper.getImageName().isEmpty() ? itemWallpaper.getCName() : itemWallpaper.getImageName() + " - " + itemWallpaper.getCName());
                tv_resolution.setText(itemWallpaper.getResolution().isEmpty() ? "" : itemWallpaper.getResolution());
                tv_size.setText(itemWallpaper.getSize().isEmpty() ? "" : itemWallpaper.getSize());
                tv_type.setText(ApplicationUtil.getImageType(itemWallpaper.getImage().isEmpty() ? "" : itemWallpaper.getImage()));

                rating.setRating(Integer.parseInt(itemWallpaper.getAverageRate().isEmpty() ? "0" : itemWallpaper.getAverageRate()));
                fav.setLiked(itemWallpaper.getIsFav());

                if (itemWallpaper.isPremium()){
                    findViewById(R.id.iv_premium).setVisibility(Boolean.TRUE.equals(Callback.isPurchases) ? View.GONE: View.VISIBLE);
                } else {
                    findViewById(R.id.iv_premium).setVisibility(View.GONE);
                }

                tv_share.setText(ApplicationUtil.format(Integer.parseInt(itemWallpaper.getTotalShare().isEmpty() ? "0" : itemWallpaper.getTotalShare())));
                tv_set.setText(ApplicationUtil.format(Integer.parseInt(itemWallpaper.getTotalSet().isEmpty() ? "0" : itemWallpaper.getTotalSet())));
                tv_downloads.setText(ApplicationUtil.format(Integer.parseInt(itemWallpaper.getTotalDownloads().isEmpty() ? "0" : itemWallpaper.getTotalDownloads())));

                if (itemWallpaper.getVibrantColor() != 0){
                    try {
                        iv_setAs.setBackgroundTintList(ColorStateList.valueOf(itemWallpaper.getVibrantColor()));
                        iv_download.setBackgroundTintList(ColorStateList.valueOf(itemWallpaper.getVibrantColor()));
                        iv_star.setBackgroundTintList(ColorStateList.valueOf(itemWallpaper.getVibrantColor()));
                        iv_share.setBackgroundTintList(ColorStateList.valueOf(itemWallpaper.getVibrantColor()));
                        iv_fav.setBackgroundTintList(ColorStateList.valueOf(itemWallpaper.getVibrantColor()));
                    } catch (Exception e) {
                        whiteVibrantColor(viewpager.getCurrentItem());
                        e.printStackTrace();
                    }
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void updateData(String updateType, int pos) {
        try {
            if (helper.isNetworkAvailable()){
                boolean is_update = false;
                RequestBody requestBody = null;
                if (updateType.equals("view")){
                    is_update = true;
                    requestBody = helper.getAPIRequest(Callback.METHOD_GIF_SINGLE, 0, Callback.arrayListLiveWallpapers.get(pos).getId(), "", "", "", new SharedPref(this).getUserId(), "", "", "", "", "", "", "view", null);
                } else if (updateType.equals(getString(R.string.download))){
                    is_update = true;
                    requestBody = helper.getAPIRequest(Callback.METHOD_GIF_SINGLE, 0, Callback.arrayListLiveWallpapers.get(pos).getId(), "", "", "", new SharedPref(this).getUserId(), "", "", "", "", "", "", "download", null);
                } else if (updateType.equals(getString(R.string.share))){
                    is_update = true;
                    requestBody = helper.getAPIRequest(Callback.METHOD_GIF_SINGLE, 0, Callback.arrayListLiveWallpapers.get(pos).getId(), "", "", "", new SharedPref(this).getUserId(), "", "", "", "", "", "", "share", null);
                } else if (updateType.equals(getString(R.string.set_wallpaper))){
                    is_update = true;
                    requestBody = helper.getAPIRequest(Callback.METHOD_GIF_SINGLE, 0, Callback.arrayListLiveWallpapers.get(pos).getId(), "", "", "", new SharedPref(this).getUserId(), "", "", "", "", "", "", "set_wallpaper", null);
                }
                LoadUpdateTask updateTask = new LoadUpdateTask(new UpdateListener() {
                    @Override
                    public void onStart() {

                    }

                    @Override
                    public void onEnd(String success, String downloads, String resolution, String size, String set, String share) {
                        if (success.equals("1")) {
                            if (updateType.equals("view")){
                                int tot = Integer.parseInt(Callback.arrayListLiveWallpapers.get(pos).getTotalViews());
                                Callback.arrayListLiveWallpapers.get(pos).setTotalViews("" + (tot + 1));
                            }
                            if (!downloads.isEmpty()){
                                Callback.arrayListLiveWallpapers.get(pos).setTotalDownloads(downloads);
                            }
                            if (!resolution.isEmpty()){
                                Callback.arrayListLiveWallpapers.get(pos).setResolution(resolution);
                            }
                            if (!size.isEmpty()){
                                Callback.arrayListLiveWallpapers.get(pos).setSize(size);
                            }
                            if (!set.isEmpty()){
                                Callback.arrayListLiveWallpapers.get(pos).setTotalSet(set);
                            }
                            if (!share.isEmpty()){
                                Callback.arrayListLiveWallpapers.get(pos).setTotalShare(share);
                            }
                            getData();
                            loadVibrantColor(pos);
                        }
                    }
                }, requestBody);
                if (is_update){
                    updateTask.execute();
                }
            } else {
                showSnackBar(false, getString(R.string.err_internet_not_connected));
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void loadVibrantColor(int pos) {
        if (Callback.arrayListLiveWallpapers.get(pos).getVibrantColor() == 0){
            try {
                Picasso.get()
                        .load(Callback.arrayListLiveWallpapers.get(pos).getImage())
                        .centerCrop()
                        .resize(200,200)
                        .into(new Target() {
                            @Override
                            public void onBitmapLoaded(Bitmap bitmap, Picasso.LoadedFrom from) {
                                try {
                                    Palette.from(bitmap).generate(palette -> {
                                        if (palette != null){
                                            try{
                                                int defaultValue = 0x000000;
                                                int vibrant = palette.getVibrantColor(defaultValue);
                                                Callback.arrayListLiveWallpapers.get(pos).setVibrantColor(vibrant);
                                                if (pos == viewpager.getCurrentItem()){
                                                    iv_setAs.setBackgroundTintList(ColorStateList.valueOf(vibrant));
                                                    iv_download.setBackgroundTintList(ColorStateList.valueOf(vibrant));
                                                    iv_star.setBackgroundTintList(ColorStateList.valueOf(vibrant));
                                                    iv_share.setBackgroundTintList(ColorStateList.valueOf(vibrant));
                                                    iv_fav.setBackgroundTintList(ColorStateList.valueOf(vibrant));
                                                }
                                            } catch (Exception e) {
                                                whiteVibrantColor(pos);
                                                e.printStackTrace();
                                            }
                                        }
                                    });
                                } catch (Exception e) {
                                    e.printStackTrace();
                                }
                            }

                            @Override
                            public void onBitmapFailed(Exception e, Drawable errorDrawable) {
                                whiteVibrantColor(pos);
                            }

                            @Override
                            public void onPrepareLoad(Drawable placeHolderDrawable) {

                            }
                        });
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    private void whiteVibrantColor(int pos) {
        try {
            Callback.arrayListLiveWallpapers.get(pos).setVibrantColor(0);
            if (pos == viewpager.getCurrentItem()){
                iv_setAs.setBackgroundTintList(ColorStateList.valueOf(ContextCompat.getColor(GIFDetailsActivity.this, R.color.white)));
                iv_download.setBackgroundTintList(ColorStateList.valueOf(ContextCompat.getColor(GIFDetailsActivity.this, R.color.white)));
                iv_star.setBackgroundTintList(ColorStateList.valueOf(ContextCompat.getColor(GIFDetailsActivity.this, R.color.white)));
                iv_share.setBackgroundTintList(ColorStateList.valueOf(ContextCompat.getColor(GIFDetailsActivity.this, R.color.white)));
                iv_fav.setBackgroundTintList(ColorStateList.valueOf(ContextCompat.getColor(GIFDetailsActivity.this, R.color.white)));
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void showRateDialog() {
        if (helper.isNetworkAvailable()){
            ReviewDialog reviewDialog = new ReviewDialog(this, new ReviewDialog.RatingDialogListener() {
                @Override
                public void onShow() {
                }

                @Override
                public void onGetRating(String rating, String message) {
                    Callback.arrayListLiveWallpapers.get(viewpager.getCurrentItem()).setUserRating(String.valueOf(rating));
                    Callback.arrayListLiveWallpapers.get(viewpager.getCurrentItem()).setUserMessage(message);
                }

                @Override
                public void onDismiss(String success, String rateSuccess, String message, int is_rating, String userRating, String userMessage) {
                    if (success.equals("1")) {
                        if (rateSuccess.equals("1")) {
                            try {
                                Callback.arrayListLiveWallpapers.get(viewpager.getCurrentItem()).setAverageRate(String.valueOf(is_rating));
                                Callback.arrayListLiveWallpapers.get(viewpager.getCurrentItem()).setTotalRate(String.valueOf(Integer.parseInt(Callback.arrayListLiveWallpapers.get(viewpager.getCurrentItem()).getTotalRate() + 1)));
                                Callback.arrayListLiveWallpapers.get(viewpager.getCurrentItem()).setUserRating(String.valueOf(userRating));
                                Callback.arrayListLiveWallpapers.get(viewpager.getCurrentItem()).setUserMessage(String.valueOf(userMessage));
                                rating.setRating(is_rating);
                            } catch (Exception e) {
                                e.printStackTrace();
                            }
                        }
                        showSnackBar(false, message);
                    } else {
                        showSnackBar(false, getString(R.string.err_server_not_connected));
                    }
                }
            });
            reviewDialog.showDialog(
                    Callback.arrayListLiveWallpapers.get(viewpager.getCurrentItem()).getId(),
                    Callback.arrayListLiveWallpapers.get(viewpager.getCurrentItem()).getUserRating(),
                    Callback.arrayListLiveWallpapers.get(viewpager.getCurrentItem()).getUserMessage(),
                    "gif"
            );
        } else {
            showSnackBar(false, getString(R.string.err_internet_not_connected));
        }
    }

    private void loadFav() {
        if (sharedPref.isLogged()) {
            if (helper.isNetworkAvailable()) {
                LoadStatus loadFav = new LoadStatus(new SuccessListener() {
                    @Override
                    public void onStart() {
                        fav.setLiked(!Callback.arrayListLiveWallpapers.get(viewpager.getCurrentItem()).getIsFav());
                    }

                    @Override
                    public void onEnd(String success, String favSuccess, String message) {
                        if (success.equals("1")) {
                            Callback.arrayListLiveWallpapers.get(viewpager.getCurrentItem()).setIsFav(favSuccess.equals("1"));
                            fav.setLiked(Callback.arrayListLiveWallpapers.get(viewpager.getCurrentItem()).getIsFav());
                            showSnackBar(true, message);
                        } else {
                            showSnackBar(false, getString(R.string.err_server_not_connected));
                        }
                    }
                }, helper.getAPIRequest(Callback.METHOD_DO_FAV, 0, Callback.arrayListLiveWallpapers.get(viewpager.getCurrentItem()).getId(), "", "", "", sharedPref.getUserId(), "", "", "", "", "", "", "gif", null));
                loadFav.execute();
            } else {
                showSnackBar(false, getString(R.string.err_internet_not_connected));
            }
        } else {
            helper.clickLogin();
        }
    }

    @Override
    public int setLayoutResourceId() {
        return R.layout.activity_wallpaper_details;
    }

    @Override
    public int setAppCompat() {
        return AppCompat.COMPAT();
    }

    public void showSnackBar(boolean success, String message) {
        Snackbar snackbar = Snackbar.make(coordinatorLayout, message, Snackbar.LENGTH_SHORT);
        snackbar.getView().setBackgroundResource(success ? R.drawable.bg_snack_bar_success : R.drawable.bg_snack_bar);
        snackbar.show();
    }

    private class ImagePagerAdapter extends PagerAdapter {

        private final LayoutInflater inflater;

        ImagePagerAdapter() {
            inflater = getLayoutInflater();
        }

        @Override
        public int getCount() {
            return Callback.arrayListLiveWallpapers.size();
        }

        @Override
        public boolean isViewFromObject(@NonNull View view, @NonNull Object object) {
            return view.equals(object);
        }

        @NonNull
        @Override
        public Object instantiateItem(@NonNull ViewGroup container, final int position) {
            View imageLayout = inflater.inflate(R.layout.layout_pv_wall, container, false);
            assert imageLayout != null;

            final TouchImageView iv_wallpaper = imageLayout.findViewById(R.id.iv_wallpaper);
            final ProgressBar progressBar = imageLayout.findViewById(R.id.pb_wall_details);

            Glide.with(GIFDetailsActivity.this)
                .asGif()
                .load(Callback.arrayListLiveWallpapers.get(position).getImage())
                .placeholder(Boolean.TRUE.equals(new ThemeEngine(GIFDetailsActivity.this).getIsThemeMode()) ? R.drawable.ic_placeholder_portrait_n : R.drawable.ic_placeholder_portrait_l)
                .listener(new RequestListener<GifDrawable>() {
                    @Override
                    public boolean onLoadFailed(@Nullable GlideException e, Object model, com.bumptech.glide.request.target.Target<GifDrawable> target, boolean isFirstResource) {
                        progressBar.setVisibility(View.GONE);
                        return false;
                    }

                    @Override
                    public boolean onResourceReady(GifDrawable resource, Object model, com.bumptech.glide.request.target.Target<GifDrawable> target, DataSource dataSource, boolean isFirstResource) {
                        progressBar.setVisibility(View.GONE);
                        return false;
                    }
                })
                .into(iv_wallpaper);

            container.addView(imageLayout, 0);
            return imageLayout;
        }

        @Override
        public void destroyItem(@NonNull ViewGroup container, int position, @NonNull Object object) {
            container.removeView((View) object);
        }
    }

    @NonNull
    private Boolean checkPer() {
        if (Build.VERSION.SDK_INT >= 33){
            if ((ContextCompat.checkSelfPermission(GIFDetailsActivity.this, READ_MEDIA_IMAGES) != PackageManager.PERMISSION_GRANTED)) {
                requestPermissions(new String[]{READ_MEDIA_IMAGES}, MY_PERMISSIONS_REQUEST_WRITE_EXTERNAL_STORAGE);
                return false;
            } else {
                return true;
            }
        } else if (Build.VERSION.SDK_INT >= 29) {
            if ((ContextCompat.checkSelfPermission(GIFDetailsActivity.this, READ_EXTERNAL_STORAGE) != PackageManager.PERMISSION_GRANTED)) {
                requestPermissions(new String[]{READ_EXTERNAL_STORAGE}, MY_PERMISSIONS_REQUEST_WRITE_EXTERNAL_STORAGE);
                return false;
            } else {
                return true;
            }
        } else {
            if ((ContextCompat.checkSelfPermission(GIFDetailsActivity.this, WRITE_EXTERNAL_STORAGE) != PackageManager.PERMISSION_GRANTED) && (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M)) {
                requestPermissions(new String[]{WRITE_EXTERNAL_STORAGE}, MY_PERMISSIONS_REQUEST_WRITE_EXTERNAL_STORAGE);
                return false;
            }
            return true;
        }
    }

    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        boolean canUseExternalStorage = false;
        if (requestCode == MY_PERMISSIONS_REQUEST_WRITE_EXTERNAL_STORAGE) {
            if (grantResults.length > 0 && grantResults[0] == PackageManager.PERMISSION_GRANTED) {
                canUseExternalStorage = true;
            }
            if (!canUseExternalStorage) {
                Toast.makeText(GIFDetailsActivity.this, getResources().getString(R.string.err_cannot_use_features), Toast.LENGTH_SHORT).show();
            }
        }
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.menu_wallpaper, menu);
        return super.onCreateOptionsMenu(menu);
    }

    @Override
    public boolean onOptionsItemSelected(@NonNull MenuItem menuItem) {
        int itemId = menuItem.getItemId();
        if (itemId == android.R.id.home) {
            finish();
        } else if (itemId == R.id.item_bug) {
            if (Callback.arrayListLiveWallpapers.get(viewpager.getCurrentItem()) != null) {
                new FeedBackDialog(this).showDialog(Callback.arrayListLiveWallpapers.get(viewpager.getCurrentItem()).getId(), "wallpaper");
            }
        } else {
            return super.onOptionsItemSelected(menuItem);
        }
        return true;
    }

    @Subscribe(sticky = true, threadMode = ThreadMode.MAIN)
    public void onDownload(EventAction eventAction) {
        try {
            updateData(getString(R.string.download), viewpager.getCurrentItem());
            GlobalBus.getBus().removeStickyEvent(eventAction);
        } catch (Exception e) {
            GlobalBus.getBus().removeStickyEvent(eventAction);
            e.printStackTrace();
        }
    }

    @Override
    public void onStart() {
        super.onStart();
        GlobalBus.getBus().register(this);
    }

    @Override
    public void onStop() {
        GlobalBus.getBus().unregister(this);
        super.onStop();
    }
}