package nemosofts.hd.wallpaper.activity;

import android.annotation.SuppressLint;
import android.app.ProgressDialog;
import android.app.WallpaperManager;
import android.graphics.Bitmap;
import android.os.AsyncTask;
import android.os.Build;
import android.os.Bundle;
import android.view.MenuItem;
import android.view.View;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.nemosofts.AppCompat;
import androidx.nemosofts.AppCompatActivity;

import com.google.android.material.bottomsheet.BottomSheetDialog;
import com.theartofdev.edmodo.cropper.CropImageView;

import nemosofts.hd.wallpaper.R;
import nemosofts.hd.wallpaper.callback.Callback;
import nemosofts.hd.wallpaper.utils.IfSupported;
import nemosofts.hd.wallpaper.utils.helper.Helper;

public class SetWallpaperActivity extends AppCompatActivity {

    Helper helper;
    CropImageView imageView;
    Bitmap bmImg;
    ProgressDialog progressDialog;
    BottomSheetDialog dialog_desc;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        IfSupported.IsRTL(this);
        IfSupported.IsScreenshot(this);

        helper = new Helper(this);

        progressDialog = new ProgressDialog(this, R.style.dialogTheme);
        progressDialog.setMessage(getString(R.string.loading));

        imageView = findViewById(R.id.iv_crop);
        imageView.setImageUriAsync(Callback.uri_set);

        findViewById(R.id.button_setwallpaper).setOnClickListener(v -> showBottomSheetDialog());
        findViewById(R.id.iv_back_crop).setOnClickListener(v -> finish());
    }

    @Override
    public boolean onOptionsItemSelected(@NonNull MenuItem item) {
        int id = item.getItemId();
        if (id == android.R.id.home) {
            onBackPressed();
            return true;
        }
        return super.onOptionsItemSelected(item);
    }

    @Override
    public int setLayoutResourceId() {
        return R.layout.activity_set_wallpaper;
    }

    @Override
    public int setAppCompat() {
        return AppCompat.COMPAT_N();
    }

    public void showBottomSheetDialog() {
        @SuppressLint("InflateParams") View view = getLayoutInflater().inflate(R.layout.layout_set_wall_op, null);
        dialog_desc = new BottomSheetDialog(this);
        dialog_desc.setContentView(view);
        dialog_desc.findViewById(R.id.ll_set_home).setOnClickListener(v -> new SetWall().execute("home"));
        dialog_desc.findViewById(R.id.ll_set_lock).setOnClickListener(v -> new SetWall().execute("lock"));
        dialog_desc.findViewById(R.id.ll_set_both).setOnClickListener(v -> new SetWall().execute("all"));
        dialog_desc.show();
    }

    @SuppressLint("StaticFieldLeak")
    private class SetWall extends AsyncTask<String, String, String> {
        @Override
        protected void onPreExecute() {
            progressDialog.show();
            bmImg = imageView.getCroppedImage();
            super.onPreExecute();
        }

        @NonNull
        @Override
        protected String doInBackground(String... strings) {
            WallpaperManager myWallpaperManager = WallpaperManager.getInstance(getApplicationContext());
            try {
                myWallpaperManager.setWallpaperOffsetSteps(0, 0);
                if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.N) {
                    String lock_type = strings[0];
                    switch (lock_type) {
                        case "home" ->
                                myWallpaperManager.setBitmap(bmImg, null, true, WallpaperManager.FLAG_SYSTEM);
                        case "lock" ->
                                myWallpaperManager.setBitmap(bmImg, null, true, WallpaperManager.FLAG_LOCK);
                        case "all" -> myWallpaperManager.setBitmap(bmImg);
                    }
                } else {
                    myWallpaperManager.setBitmap(bmImg);
                }
            } catch (Exception e) {
                e.printStackTrace();
                return "0";
            }
            return "1";
        }

        @Override
        protected void onPostExecute(@NonNull String s) {
            if (s.equals("1")) {
                Toast.makeText(SetWallpaperActivity.this, getString(R.string.wallpaper_set), Toast.LENGTH_SHORT).show();
                finish();
            } else {
                Toast.makeText(SetWallpaperActivity.this, getString(R.string.err_set_wall), Toast.LENGTH_SHORT).show();
            }
            progressDialog.dismiss();
            super.onPostExecute(s);
        }
    }

}