package nemosofts.hd.wallpaper.adapter;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.content.Context;
import android.graphics.Color;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.RatingBar;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.constraintlayout.widget.ConstraintLayout;
import androidx.nemosofts.theme.ThemeEngine;
import androidx.recyclerview.widget.RecyclerView;

import com.applovin.mediation.MaxAd;
import com.applovin.mediation.MaxError;
import com.applovin.mediation.nativeAds.MaxNativeAdListener;
import com.applovin.mediation.nativeAds.MaxNativeAdLoader;
import com.applovin.mediation.nativeAds.MaxNativeAdView;
import com.google.ads.mediation.admob.AdMobAdapter;
import com.google.ads.mediation.facebook.FacebookMediationAdapter;
import com.google.android.gms.ads.AdLoader;
import com.google.android.gms.ads.AdRequest;
import com.google.android.gms.ads.nativead.MediaView;
import com.google.android.gms.ads.nativead.NativeAd;
import com.google.android.gms.ads.nativead.NativeAdView;
import com.ironsource.mediationsdk.ISBannerSize;
import com.ironsource.mediationsdk.IronSource;
import com.ironsource.mediationsdk.IronSourceBannerLayout;
import com.ironsource.mediationsdk.logger.IronSourceError;
import com.like.LikeButton;
import com.like.OnLikeListener;
import com.makeramen.roundedimageview.RoundedImageView;
import com.squareup.picasso.Picasso;
import com.startapp.sdk.ads.nativead.NativeAdPreferences;
import com.startapp.sdk.ads.nativead.StartAppNativeAd;
import com.startapp.sdk.adsbase.Ad;
import com.startapp.sdk.adsbase.adlisteners.AdEventListener;
import com.wortise.ads.AdError;
import com.wortise.ads.natives.GoogleNativeAd;

import java.util.ArrayList;
import java.util.List;

import nemosofts.hd.wallpaper.R;
import nemosofts.hd.wallpaper.asyncTask.LoadStatus;
import nemosofts.hd.wallpaper.callback.Callback;
import nemosofts.hd.wallpaper.interfaces.RecyclerViewClickListener;
import nemosofts.hd.wallpaper.interfaces.SuccessListener;
import nemosofts.hd.wallpaper.item.ItemWallpaper;
import nemosofts.hd.wallpaper.utils.ApplicationUtil;
import nemosofts.hd.wallpaper.utils.SharedPref;
import nemosofts.hd.wallpaper.utils.helper.Helper;

public class AdapterLiveWallpaper extends RecyclerView.Adapter<RecyclerView.ViewHolder> {

    ArrayList<ItemWallpaper> arrayList;
    Context context;
    RecyclerViewClickListener recyclerViewClickListener;
    Helper helper;
    SharedPref sharedPref;
    int columnWidth = 0, columnHeight = 0;

    Boolean isAdLoaded = false;
    List<NativeAd> mNativeAdsAdmob = new ArrayList<>();

    public AdapterLiveWallpaper(Context context, ArrayList<ItemWallpaper> arrayList, RecyclerViewClickListener recyclerViewClickListener) {
        this.arrayList = arrayList;
        this.context = context;
        helper = new Helper(context);
        sharedPref = new SharedPref(context);
        this.recyclerViewClickListener = recyclerViewClickListener;
        columnWidth = ApplicationUtil.getColumnWidth(3, 3, context);
        columnHeight = (int) (columnWidth * 1.55);
        if (helper.canLoadNativeAds(context, Callback.PAGE_NATIVE_POST)) {
            loadNativeAds();
        }
    }

    private class MyViewHolder extends RecyclerView.ViewHolder {

        ConstraintLayout rootlayout;
        LikeButton likeButton;
        RoundedImageView iv_wallpaper;
        TextView textView_cat;
        View vieww;
        ImageView iv_wallpaper_pre;

        private MyViewHolder(View view) {
            super(view);
            textView_cat = view.findViewById(R.id.tv_wall_cat);
            vieww = view.findViewById(R.id.view_wall);
            rootlayout = view.findViewById(R.id.rootlayout);
            likeButton = view.findViewById(R.id.button_wall_fav);
            iv_wallpaper = view.findViewById(R.id.iv_wallpaper);
            iv_wallpaper_pre = view.findViewById(R.id.iv_wallpaper_pre);
        }
    }

    private static class ADViewHolder extends RecyclerView.ViewHolder {
        private RelativeLayout rl_native_ad;
        boolean isAdRequested = false;

        private ADViewHolder(View view) {
            super(view);
            rl_native_ad = view.findViewById(R.id.rl_native_ad);
        }
    }

    @NonNull
    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        if (viewType >= 1000) {
            View itemView = LayoutInflater.from(parent.getContext()).inflate(R.layout.layout_native_ad, parent, false);
            return new ADViewHolder(itemView);
        } else {
            View itemView = LayoutInflater.from(parent.getContext()).inflate(R.layout.layout_wallpaper, parent, false);
            return new MyViewHolder(itemView);
        }
    }

    @Override
    public void onBindViewHolder(@NonNull final RecyclerView.ViewHolder holder, int position) {
        if (holder instanceof MyViewHolder) {
            ((MyViewHolder) holder).likeButton.setLiked(arrayList.get(holder.getAdapterPosition()).getIsFav());
            ((MyViewHolder) holder).textView_cat.setText(arrayList.get(holder.getAdapterPosition()).getName());

            Picasso.get()
                    .load(arrayList.get(position).getImage())
                    .placeholder(Boolean.TRUE.equals(new ThemeEngine(context).getIsThemeMode()) ? R.drawable.ic_placeholder_portrait_n : R.drawable.ic_placeholder_portrait_l)
                    .into(((MyViewHolder) holder).iv_wallpaper);

            if (Boolean.FALSE.equals(Callback.isPurchases)){
                ((MyViewHolder) holder).iv_wallpaper_pre.setVisibility(arrayList.get(position).isPremium()? View.VISIBLE :View.GONE);
            } else {
                ((MyViewHolder) holder).iv_wallpaper_pre.setVisibility(View.GONE);
            }

            if (sharedPref.isLogged()) {
                ((MyViewHolder) holder).likeButton.setOnLikeListener(new OnLikeListener() {
                    @Override
                    public void liked(LikeButton likeButton) {
                        try {
                            loadFav(holder.getAdapterPosition());
                        } catch (Exception e) {
                            e.printStackTrace();
                        }
                    }

                    @Override
                    public void unLiked(LikeButton likeButton) {
                        try {
                            loadFav(holder.getAdapterPosition());
                        } catch (Exception e) {
                            e.printStackTrace();
                        }
                    }
                });
            } else {
                ((MyViewHolder) holder).likeButton.setOnClickListener(view -> {
                    if (!sharedPref.isLogged()) {
                        helper.clickLogin();
                    }
                });
            }

            ((MyViewHolder) holder).iv_wallpaper.setOnClickListener(view -> recyclerViewClickListener.onClick(holder.getAdapterPosition()));
        } else if (holder instanceof ADViewHolder && (Boolean.TRUE.equals(isAdLoaded) && (((ADViewHolder) holder).rl_native_ad.getChildCount() == 0))) {
            switch (Callback.adNetwork) {
                case Callback.AD_TYPE_ADMOB, Callback.AD_TYPE_META -> {
                    if (!mNativeAdsAdmob.isEmpty()) {

                        int i = ApplicationUtil.getRandom(mNativeAdsAdmob.size() - 1);

                        @SuppressLint("InflateParams") NativeAdView adView = (NativeAdView) ((Activity) context).getLayoutInflater().inflate(R.layout.layout_native_ad_admob_grid, null);
                        populateUnifiedNativeAdView(mNativeAdsAdmob.get(i), adView);
                        ((ADViewHolder) holder).rl_native_ad.removeAllViews();
                        ((ADViewHolder) holder).rl_native_ad.addView(adView);

                        ((ADViewHolder) holder).rl_native_ad.setVisibility(View.VISIBLE);
                    }
                }
                case Callback.AD_TYPE_STARTAPP -> {
                    StartAppNativeAd nativeAd = new StartAppNativeAd(context);
                    nativeAd.loadAd(new NativeAdPreferences().setAdsNumber(1).setAutoBitmapDownload(true).setPrimaryImageSize(2), new AdEventListener() {
                        @Override
                        public void onReceiveAd(@NonNull Ad ad) {
                            try {
                                if (!nativeAd.getNativeAds().isEmpty()) {
                                    @SuppressLint("InflateParams") RelativeLayout nativeAdView = (RelativeLayout) ((Activity) context).getLayoutInflater().inflate(R.layout.layout_native_ad_startapp_grid, null);

                                    ImageView icon = nativeAdView.findViewById(R.id.icon);
                                    TextView title = nativeAdView.findViewById(R.id.title);
                                    TextView description = nativeAdView.findViewById(R.id.description);
                                    Button button = nativeAdView.findViewById(R.id.button);

                                    Picasso.get()
                                            .load(nativeAd.getNativeAds().get(0).getImageUrl())
                                            .into(icon);
                                    title.setText(nativeAd.getNativeAds().get(0).getTitle());
                                    description.setText(nativeAd.getNativeAds().get(0).getDescription());
                                    button.setText(nativeAd.getNativeAds().get(0).isApp() ? "Install" : "Open");

                                    ((ADViewHolder) holder).rl_native_ad.removeAllViews();
                                    ((ADViewHolder) holder).rl_native_ad.addView(nativeAdView);
                                    ((ADViewHolder) holder).rl_native_ad.setVisibility(View.VISIBLE);
                                }
                            } catch (Exception e) {
                                e.printStackTrace();
                            }
                        }

                        @Override
                        public void onFailedToReceiveAd(Ad ad) {
                        }
                    });
                }
                case Callback.AD_TYPE_IRONSOURCE -> {
                    IronSource.init(context, Callback.ironsourceAppKey, IronSource.AD_UNIT.BANNER);
                    IronSourceBannerLayout banner = IronSource.createBanner((Activity) context, ISBannerSize.BANNER);
                    banner.setBannerListener(new com.ironsource.mediationsdk.sdk.BannerListener() {
                        @Override
                        public void onBannerAdLoaded() {
                            ((ADViewHolder) holder).rl_native_ad.removeAllViews();
                            ((ADViewHolder) holder).rl_native_ad.addView(banner);
                            ((ADViewHolder) holder).rl_native_ad.setVisibility(View.VISIBLE);
                        }

                        @Override
                        public void onBannerAdLoadFailed(IronSourceError error) {

                        }

                        @Override
                        public void onBannerAdClicked() {
                        }

                        @Override
                        public void onBannerAdScreenPresented() {
                        }

                        @Override
                        public void onBannerAdScreenDismissed() {
                        }

                        @Override
                        public void onBannerAdLeftApplication() {
                        }
                    });
                    IronSource.loadBanner(banner);
                }
                case Callback.AD_TYPE_APPLOVIN -> {
                    MaxNativeAdLoader nativeAdLoader = new MaxNativeAdLoader(Callback.mataNativeAdID, context);
                    nativeAdLoader.setNativeAdListener(new MaxNativeAdListener() {
                        @Override
                        public void onNativeAdLoaded(final MaxNativeAdView nativeAdView, @NonNull final MaxAd ad) {
                            nativeAdView.setPadding(0, 0, 0, 10);
                            nativeAdView.setBackgroundColor(Color.WHITE);
                            ((ADViewHolder) holder).rl_native_ad.removeAllViews();
                            ((ADViewHolder) holder).rl_native_ad.addView(nativeAdView);
                            ((ADViewHolder) holder).rl_native_ad.setVisibility(View.VISIBLE);
                        }

                        @Override
                        public void onNativeAdLoadFailed(@NonNull final String adUnitId, @NonNull final MaxError error) {
                        }

                        @Override
                        public void onNativeAdClicked(@NonNull final MaxAd ad) {
                        }
                    });
                    nativeAdLoader.loadAd();
                }
                case Callback.AD_TYPE_WORTISE -> {
                    GoogleNativeAd googleNativeAd = new GoogleNativeAd(context, Callback.wortiseNativeAdID, new GoogleNativeAd.Listener() {

                        @Override
                        public void onNativeFailedToLoad(@NonNull GoogleNativeAd googleNativeAd, @NonNull AdError adError) {
                        }

                        @Override
                        public void onNativeClicked(@NonNull GoogleNativeAd googleNativeAd) {
                        }

                        @Override
                        public void onNativeImpression(@NonNull GoogleNativeAd googleNativeAd) {
                        }

                        @Override
                        public void onNativeLoaded(@NonNull GoogleNativeAd googleNativeAd, @NonNull NativeAd nativeAd) {
                            @SuppressLint("InflateParams") NativeAdView adView = (NativeAdView) ((Activity) context).getLayoutInflater().inflate(R.layout.layout_native_ad_admob, null);
                            populateUnifiedNativeAdView(nativeAd, adView);
                            ((ADViewHolder) holder).rl_native_ad.removeAllViews();
                            ((ADViewHolder) holder).rl_native_ad.addView(adView);

                            ((ADViewHolder) holder).rl_native_ad.setVisibility(View.VISIBLE);
                        }
                    });
                    googleNativeAd.load();
                }
                default -> {
                }
            }
        }
    }

    private void loadFav(int pos) {
        if (sharedPref.isLogged()) {
            if (helper.isNetworkAvailable()) {
                LoadStatus loadFav = new LoadStatus(new SuccessListener() {
                    @Override
                    public void onStart() {

                    }

                    @Override
                    public void onEnd(String success, String favSuccess, String message) {
                        if (success.equals("1")) {
                            arrayList.get(pos).setIsFav(favSuccess.equals("1"));
                            Toast.makeText(context, message, Toast.LENGTH_SHORT).show();
                        } else {
                            Toast.makeText(context, context.getString(R.string.err_server_not_connected), Toast.LENGTH_SHORT).show();
                        }
                    }
                }, helper.getAPIRequest(Callback.METHOD_DO_FAV, 0, arrayList.get(pos).getId(), "", "", "", sharedPref.getUserId(), "", "", "", "", "", "", "gif", null));
                loadFav.execute();
            } else {
                Toast.makeText(context, context.getString(R.string.err_internet_not_connected), Toast.LENGTH_SHORT).show();
            }
        } else {
            helper.clickLogin();
        }
    }

    @Override
    public int getItemCount() {
        return arrayList.size();
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    public boolean isHeader(int position) {
        return position == arrayList.size();
    }

    @Override
    public int getItemViewType(int position) {
        if (arrayList.get(position) == null) {
            return 1000 + position;
        } else {
            return position;
        }
    }

    public int getRealPos(int pos, ArrayList<ItemWallpaper> arrayListTemp) {
        return arrayListTemp.indexOf(arrayList.get(pos));
    }

    @SuppressLint("MissingPermission")
    private void loadNativeAds() {
        if (Callback.adNetwork.equals(Callback.AD_TYPE_ADMOB) || Callback.adNetwork.equals(Callback.AD_TYPE_META) && arrayList.size() >= 10) {
            AdLoader.Builder builder = new AdLoader.Builder(context, Callback.admobNativeAdID);
            Bundle extras = new Bundle();

            AdRequest adRequest;
            if(Callback.adNetwork.equals(Callback.AD_TYPE_ADMOB)) {
                adRequest = new AdRequest.Builder()
                        .addNetworkExtrasBundle(AdMobAdapter.class, extras)
                        .build();
            } else {
                adRequest = new AdRequest.Builder()
                        .addNetworkExtrasBundle(AdMobAdapter.class, new Bundle())
                        .addNetworkExtrasBundle(FacebookMediationAdapter.class, extras)
                        .build();
            }
            AdLoader adLoader = builder.forNativeAd(
                    nativeAd -> {
                        mNativeAdsAdmob.add(nativeAd);
                        if (mNativeAdsAdmob.size() == 5) {
                            isAdLoaded = true;
                        }
                    }).build();
            adLoader.loadAds(adRequest, 5);
        }
    }

    private void populateUnifiedNativeAdView(NativeAd nativeAd, NativeAdView adView) {
        // Set the media view. Media content will be automatically populated in the media view once
        // adView.setNativeAd() is called.
        MediaView mediaView = adView.findViewById(R.id.ad_media);
        mediaView.setImageScaleType(ImageView.ScaleType.FIT_CENTER);
        mediaView.setOnHierarchyChangeListener(new ViewGroup.OnHierarchyChangeListener() {
            @Override
            public void onChildViewAdded(View parent, View child) {
                float scale = context.getResources().getDisplayMetrics().density;

                int maxHeightPixels = 175;
                int maxHeightDp = (int) (maxHeightPixels * scale + 0.5f);

                if (child instanceof ImageView) { //Images
                    ImageView imageView = (ImageView) child;
                    imageView.setAdjustViewBounds(true);
                    imageView.setMaxHeight(maxHeightDp);

                } else { //Videos
                    ViewGroup.LayoutParams params = child.getLayoutParams();
                    params.height = maxHeightDp;
                    child.setLayoutParams(params);
                }
            }

            @Override
            public void onChildViewRemoved(View parent, View child) {}
        });
        adView.setMediaView(mediaView);

        // Set other ad assets.
        adView.setHeadlineView(adView.findViewById(R.id.ad_headline));
        adView.setBodyView(adView.findViewById(R.id.ad_body));
        adView.setCallToActionView(adView.findViewById(R.id.ad_call_to_action));
        adView.setIconView(adView.findViewById(R.id.ad_icon));
        adView.setPriceView(adView.findViewById(R.id.ad_price));
        adView.setStarRatingView(adView.findViewById(R.id.ad_stars));
        adView.setStoreView(adView.findViewById(R.id.ad_store));
        adView.setAdvertiserView(adView.findViewById(R.id.ad_advertiser));

        // The headline is guaranteed to be in every UnifiedNativeAd.
        ((TextView) adView.getHeadlineView()).setText(nativeAd.getHeadline());

        // These assets aren't guaranteed to be in every UnifiedNativeAd, so it's important to
        // check before trying to display them.
        if (nativeAd.getBody() == null) {
            adView.getBodyView().setVisibility(View.GONE);
        } else {
            adView.getBodyView().setVisibility(View.VISIBLE);
            ((TextView) adView.getBodyView()).setText(nativeAd.getBody());
        }

        if (nativeAd.getCallToAction() == null) {
            adView.getCallToActionView().setVisibility(View.GONE);
        } else {
            adView.getCallToActionView().setVisibility(View.VISIBLE);
            ((Button) adView.getCallToActionView()).setText(nativeAd.getCallToAction());
        }

        if (nativeAd.getIcon() == null) {
            adView.getIconView().setVisibility(View.GONE);
        } else {
            ((ImageView) adView.getIconView()).setImageDrawable(
                    nativeAd.getIcon().getDrawable());
            adView.getIconView().setVisibility(View.VISIBLE);
        }

        if (nativeAd.getPrice() == null) {
            adView.getPriceView().setVisibility(View.GONE);
        } else {
            adView.getPriceView().setVisibility(View.VISIBLE);
            ((TextView) adView.getPriceView()).setText(nativeAd.getPrice());
        }

        if (nativeAd.getStore() == null) {
            adView.getStoreView().setVisibility(View.GONE);
        } else {
            adView.getStoreView().setVisibility(View.VISIBLE);
            ((TextView) adView.getStoreView()).setText(nativeAd.getStore());
        }

        if (nativeAd.getStarRating() == null) {
            adView.getStarRatingView().setVisibility(View.GONE);
        } else {
            ((RatingBar) adView.getStarRatingView())
                    .setRating(nativeAd.getStarRating().floatValue());
            adView.getStarRatingView().setVisibility(View.VISIBLE);
        }

        if (nativeAd.getAdvertiser() == null) {
            adView.getAdvertiserView().setVisibility(View.GONE);
        } else {
            ((TextView) adView.getAdvertiserView()).setText(nativeAd.getAdvertiser());
            adView.getAdvertiserView().setVisibility(View.VISIBLE);
        }

        for (int i = 0; i < mediaView.getChildCount(); i++) {
            View view = mediaView.getChildAt(i);
            if (view instanceof ImageView) {
                ((ImageView) view).setAdjustViewBounds(true);
            }
        }

        // This method tells the Google Mobile Ads SDK that you have finished populating your
        // native ad view with this native ad. The SDK will populate the adView's MediaView
        // with the media content from this native ad.
        adView.setNativeAd(nativeAd);
    }

    public void destroyNativeAds() {
        try {
            for (int i = 0; i < mNativeAdsAdmob.size(); i++) {
                mNativeAdsAdmob.get(i).destroy();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}