package nemosofts.hd.wallpaper.adapter.home;

import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.ProgressBar;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.fragment.app.FragmentTransaction;
import androidx.recyclerview.widget.DefaultItemAnimator;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Objects;

import nemosofts.hd.wallpaper.R;
import nemosofts.hd.wallpaper.activity.MainActivity;
import nemosofts.hd.wallpaper.activity.WallpaperDetailsActivity;
import nemosofts.hd.wallpaper.callback.Callback;
import nemosofts.hd.wallpaper.fragment.online.FragmentLatest;
import nemosofts.hd.wallpaper.fragment.online.FragmentSection;
import nemosofts.hd.wallpaper.fragment.online.FragmentTrending;
import nemosofts.hd.wallpaper.interfaces.InterAdListener;
import nemosofts.hd.wallpaper.item.ItemPost;
import nemosofts.hd.wallpaper.utils.helper.Helper;

public class AdapterHome extends RecyclerView.Adapter<RecyclerView.ViewHolder> {

    Context context;
    Helper helper;
    ArrayList<ItemPost> arrayList;
    int clickPos = 0;

    final int VIEW_PROG = 0;
    final int VIEW_LATEST = 1;
    final int VIEW_ADS = 2;

    Boolean ads = true;

    public AdapterHome(Context context, ArrayList<ItemPost> arrayList) {
        this.context = context;
        this.arrayList = arrayList;
        helper = new Helper(context, interAdListener);
    }

    class LatestHolder extends RecyclerView.ViewHolder {
        RecyclerView rv_horizontal;
        AdapterHomeHorizontal adapterHomeLatest;
        TextView tv_title;
        LinearLayout ll_home_view_all;

        LatestHolder(View view) {
            super(view);
            rv_horizontal = view.findViewById(R.id.rv_home_cat);
            tv_title = view.findViewById(R.id.tv_home_title);
            ll_home_view_all = view.findViewById(R.id.ll_home_view_all);
            LinearLayoutManager linearLayoutManager = new LinearLayoutManager(context, LinearLayoutManager.HORIZONTAL, false);
            rv_horizontal.setLayoutManager(linearLayoutManager);
            rv_horizontal.setItemAnimator(new DefaultItemAnimator());
        }
    }

    static class LatestAds extends RecyclerView.ViewHolder {

        LinearLayout ll_adView;

        LatestAds(View view) {
            super(view);
            ll_adView = view.findViewById(R.id.ll_adView);
        }
    }

    private static class ProgressViewHolder extends RecyclerView.ViewHolder {
        private static ProgressBar progressBar;

        private ProgressViewHolder(View v) {
            super(v);
            progressBar = v.findViewById(R.id.progressBar);
        }
    }

    @NonNull
    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        if (viewType == VIEW_LATEST) {
            View itemView = LayoutInflater.from(parent.getContext()).inflate(R.layout.layout_home_ui_categories, parent, false);
            return new LatestHolder(itemView);
        } else if (viewType == VIEW_ADS) {
            View itemView = LayoutInflater.from(parent.getContext()).inflate(R.layout.layout_baner_ad, parent, false);
            return new LatestAds(itemView);
        } else {
            View v = LayoutInflater.from(parent.getContext()).inflate(R.layout.row_progressbar, parent, false);
            return new ProgressViewHolder(v);
        }
    }

    @Override
    public void onBindViewHolder(@NonNull RecyclerView.ViewHolder holder, int position) {

       if (holder instanceof LatestHolder && (((LatestHolder) holder).adapterHomeLatest == null)) {
            ((LatestHolder) holder).tv_title.setText(arrayList.get(holder.getAdapterPosition()).getTitle());

            ((LatestHolder) holder).adapterHomeLatest = new AdapterHomeHorizontal(context, arrayList.get(holder.getAdapterPosition()).getArrayListWallpaper(), position1 -> {
                clickPos = holder.getAdapterPosition();
                helper.showInterAd(position1, "horizontal");
            });

            ((LatestHolder) holder).rv_horizontal.setAdapter(((LatestHolder) holder).adapterHomeLatest);

            ((LatestHolder) holder).ll_home_view_all.setOnClickListener(v -> {
                if (arrayList.get(holder.getAdapterPosition()).getSections().equals("latest")){
                    FragmentLatest f_latest = new FragmentLatest();
                    FragmentTransaction ft = ((AppCompatActivity) context).getSupportFragmentManager().beginTransaction();
                    ft.setTransition(FragmentTransaction.TRANSIT_FRAGMENT_OPEN);
                    ft.hide(((AppCompatActivity) context).getSupportFragmentManager()
                            .getFragments()
                            .get(((AppCompatActivity) context).getSupportFragmentManager().getBackStackEntryCount()));
                    ft.add(R.id.fragment, f_latest, context.getString(R.string.latest));
                    ft.addToBackStack(context.getString(R.string.latest));
                    ft.commit();
                    Objects.requireNonNull(((MainActivity) context).getSupportActionBar()).setTitle(context.getString(R.string.latest));
                    ((MainActivity) context).bottomNavigationView(1);
                } else if (arrayList.get(holder.getAdapterPosition()).getSections().equals("trending")){
                    FragmentTrending f_most = new FragmentTrending();
                    FragmentTransaction ft = ((AppCompatActivity) context).getSupportFragmentManager().beginTransaction();
                    ft.setTransition(FragmentTransaction.TRANSIT_FRAGMENT_OPEN);
                    ft.hide(((AppCompatActivity) context).getSupportFragmentManager()
                            .getFragments()
                            .get(((AppCompatActivity) context).getSupportFragmentManager().getBackStackEntryCount()));
                    ft.add(R.id.fragment, f_most, context.getString(R.string.trending));
                    ft.addToBackStack(context.getString(R.string.trending));
                    ft.commit();
                    Objects.requireNonNull(((MainActivity) context).getSupportActionBar()).setTitle(context.getString(R.string.trending));
                    ((MainActivity) context).bottomNavigationView(2);
                } else {
                    FragmentSection f_Section = new FragmentSection();
                    Bundle bundle = new Bundle();
                    bundle.putString("id", arrayList.get(holder.getAdapterPosition()).getId());
                    f_Section.setArguments(bundle);
                    FragmentTransaction ft = ((AppCompatActivity) context).getSupportFragmentManager().beginTransaction();
                    ft.setTransition(FragmentTransaction.TRANSIT_FRAGMENT_OPEN);
                    ft.hide(((AppCompatActivity) context).getSupportFragmentManager()
                            .getFragments()
                            .get(((AppCompatActivity) context).getSupportFragmentManager().getBackStackEntryCount()));
                    ft.add(R.id.fragment, f_Section, context.getString(R.string.wallpapers));
                    ft.addToBackStack(context.getString(R.string.wallpapers));
                    ft.commit();
                    Objects.requireNonNull(((MainActivity) context).getSupportActionBar()).setTitle(((LatestHolder) holder).tv_title.getText().toString());
                    ((MainActivity) context).bottomNavigationView(5);
                }
            });
       }
       else if (holder instanceof LatestAds) {
           if (ads){
               ads = false;
               helper.showBannerAd(((LatestAds) holder).ll_adView, Callback.PAGE_HOME);
           }
       }
    }

    @Override
    public long getItemId(int id) {
        return id;
    }

    @Override
    public int getItemCount() {
        return arrayList.size();
    }

    public void hideHeader() {
        ProgressViewHolder.progressBar.setVisibility(View.GONE);
    }

    public boolean isHeader(int position) {
        return arrayList.get(position) == null;
    }

    @Override
    public int getItemViewType(int position) {
        return switch (arrayList.get(position).getType()) {
            case "wallpaper" -> VIEW_LATEST;
            case "ads" -> VIEW_ADS;
            default -> VIEW_PROG;
        };
    }

    InterAdListener interAdListener = new InterAdListener() {
        @Override
        public void onClick(int position, @NonNull String type) {
            Callback.arrayList.clear();
            Callback.arrayList.addAll(arrayList.get(clickPos).getArrayListWallpaper());
            Callback.arrayList.removeAll(Collections.singleton(null));

            int real_pos = arrayList.get(clickPos).getArrayListWallpaper().indexOf(arrayList.get(clickPos).getArrayListWallpaper().get(position));

            Intent intent = new Intent(context, WallpaperDetailsActivity.class);
            intent.putExtra("pos", real_pos);
            intent.putExtra("pos_type", 10);
            intent.putExtra("page", 0);
            intent.putExtra("color_ids", "");
            context.startActivity(intent);
        }
    };
}