package nemosofts.hd.wallpaper.asyncTask;

import android.os.AsyncTask;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;

import nemosofts.hd.wallpaper.callback.Callback;
import nemosofts.hd.wallpaper.interfaces.HomeListener;
import nemosofts.hd.wallpaper.item.ItemColors;
import nemosofts.hd.wallpaper.item.ItemPost;
import nemosofts.hd.wallpaper.item.ItemWallpaper;
import nemosofts.hd.wallpaper.utils.ApplicationUtil;
import okhttp3.RequestBody;

public class LoadHome extends AsyncTask<String, String, String> {

    RequestBody requestBody;
    HomeListener homeListener;
    ArrayList<ItemPost> arrayListPost = new ArrayList<>();
    String message = "", successAPI = "1";

    public LoadHome(HomeListener homeListener, RequestBody requestBody) {
        this.homeListener = homeListener;
        this.requestBody = requestBody;
    }

    @Override
    protected void onPreExecute() {
        homeListener.onStart();
        super.onPreExecute();
    }

    @Override
    protected String doInBackground(String... strings) {
        try {
            String json = ApplicationUtil.responsePost(Callback.API_URL, requestBody);
            JSONObject mainJson = new JSONObject(json);

            try {

                JSONObject jsonObject = mainJson.getJSONObject(Callback.TAG_ROOT);

                ItemPost itemPost;
                String postTitle, postType, postId;

                if (jsonObject.has("wallpaper_colors")) {

                    JSONArray jsonArray_color = jsonObject.getJSONArray("wallpaper_colors");
                    if (jsonArray_color.length() > 0) {

                        ArrayList<ItemColors> arrayListColors = new ArrayList<>();
                        for (int i = 0; i < jsonArray_color.length(); i++) {
                            JSONObject objJson = jsonArray_color.getJSONObject(i);

                            String id = objJson.getString("color_id");
                            String name = objJson.getString("color_name");
                            String code = objJson.getString("color_code");

                            ItemColors itemColors = new ItemColors(id, name, code);
                            arrayListColors.add(itemColors);
                        }
                        if (!arrayListColors.isEmpty()){
                            if (!Callback.arrayListColors.isEmpty()){
                                Callback.arrayListColors.clear();
                            }
                            Callback.arrayListColors.addAll(arrayListColors);
                        }
                    }
                }

                if (jsonObject.has("latest_wallpaper")) {

                    JSONArray jsonArrayArtist = jsonObject.getJSONArray("latest_wallpaper");

                    if (jsonArrayArtist.length() > 0) {

                        postTitle = "Latest Wallpaper";
                        postType = "wallpaper";
                        itemPost = new ItemPost("", postTitle, postType,"latest");

                        ArrayList<ItemWallpaper> arrayList = new ArrayList<>();
                        for (int i = 0; i < jsonArrayArtist.length(); i++) {
                            JSONObject objJson = jsonArrayArtist.getJSONObject(i);

                            String id = objJson.getString("id");
                            String cid = objJson.getString("cat_id");
                            String cat_name = objJson.getString("category_name");
                            String img_name = objJson.getString("img_name");
                            String img = objJson.getString("wallpaper_image").replace(" ", "%20");
                            String total_views = objJson.getString("total_views");
                            String total_rate = objJson.getString("total_rate");
                            String rate_avg = objJson.getString("rate_avg");
                            boolean isPremium = objJson.getString("pay").equals("premium");
                            boolean isFav = objJson.getBoolean("is_favorite");
                            String img_type = objJson.getString("img_type");

                            ItemWallpaper itemWallpaper = new ItemWallpaper(id, cid, cat_name, img, total_views, total_rate, rate_avg, isPremium, "", isFav,img_type, img_name);
                            arrayList.add(itemWallpaper);
                        }
                        itemPost.setArrayListWallpaper(arrayList);
                        arrayListPost.add(itemPost);
                    }
                }

                if (jsonObject.has("popular_wallpaper")) {

                    JSONArray jsonArrayArtist = jsonObject.getJSONArray("popular_wallpaper");

                    if (jsonArrayArtist.length() > 0) {

                        postTitle = "Popular Wallpaper";
                        postType = "wallpaper";
                        itemPost = new ItemPost("", postTitle, postType, "trending");

                        ArrayList<ItemWallpaper> arrayList = new ArrayList<>();
                        for (int i = 0; i < jsonArrayArtist.length(); i++) {
                            JSONObject objJson = jsonArrayArtist.getJSONObject(i);

                            String id = objJson.getString("id");
                            String cid = objJson.getString("cat_id");
                            String cat_name = objJson.getString("category_name");
                            String img_name = objJson.getString("img_name");
                            String img = objJson.getString("wallpaper_image").replace(" ", "%20");
                            String total_views = objJson.getString("total_views");
                            String total_rate = objJson.getString("total_rate");
                            String rate_avg = objJson.getString("rate_avg");
                            boolean isPremium = objJson.getString("pay").equals("premium");
                            boolean isFav = objJson.getBoolean("is_favorite");
                            String img_type = objJson.getString("img_type");

                            ItemWallpaper itemWallpaper = new ItemWallpaper(id, cid, cat_name, img, total_views, total_rate, rate_avg, isPremium, "", isFav,img_type, img_name);
                            arrayList.add(itemWallpaper);
                        }
                        itemPost.setArrayListWallpaper(arrayList);
                        arrayListPost.add(itemPost);
                    }
                }

                if (jsonObject.has("home_sections")) {

                    JSONArray jsonArraySection = jsonObject.getJSONArray("home_sections");

                    for (int j = 0; j < jsonArraySection.length(); j++) {

                        JSONObject jObjHome = jsonArraySection.getJSONObject(j);

                        postId = jObjHome.getString("home_id");
                        postTitle = jObjHome.getString("home_title");
                        itemPost = new ItemPost(postId, postTitle, "wallpaper", "sections");

                        if (jObjHome.has("home_content")) {
                            JSONArray jsonArrayHomeContent = jObjHome.getJSONArray("home_content");

                            ArrayList<ItemWallpaper> arrayList = new ArrayList<>();
                            for (int i = 0; i < jsonArrayHomeContent.length(); i++) {
                                JSONObject objJson = jsonArrayHomeContent.getJSONObject(i);

                                String id = objJson.getString("id");
                                String cid = objJson.getString("cat_id");
                                String cat_name = objJson.getString("category_name");
                                String img_name = objJson.getString("img_name");
                                String img = objJson.getString("wallpaper_image").replace(" ", "%20");
                                String total_views = objJson.getString("total_views");
                                String total_rate = objJson.getString("total_rate");
                                String rate_avg = objJson.getString("rate_avg");
                                boolean isPremium = objJson.getString("pay").equals("premium");
                                boolean isFav = objJson.getBoolean("is_favorite");
                                String img_type = objJson.getString("img_type");

                                ItemWallpaper itemWallpaper = new ItemWallpaper(id, cid, cat_name, img, total_views, total_rate, rate_avg, isPremium, "", isFav,img_type, img_name);
                                arrayList.add(itemWallpaper);
                            }
                            itemPost.setArrayListWallpaper(arrayList);
                            arrayListPost.add(itemPost);
                        }
                    }
                }

            } catch (Exception e) {
                JSONArray jsonArray = mainJson.getJSONArray(Callback.TAG_ROOT);
                JSONObject jsonObject = jsonArray.getJSONObject(0);
                successAPI = jsonObject.getString(Callback.TAG_SUCCESS);
                message = jsonObject.getString(Callback.TAG_MSG);

                e.printStackTrace();
            }
            return "1";
        } catch (Exception e) {
            e.printStackTrace();
            return "0";
        }
    }

    @Override
    protected void onPostExecute(String s) {
        homeListener.onEnd(s, message, arrayListPost);
        super.onPostExecute(s);
    }

}