package nemosofts.hd.wallpaper.asyncTask;

import android.os.AsyncTask;

import org.json.JSONArray;
import org.json.JSONObject;

import nemosofts.hd.wallpaper.callback.Callback;
import nemosofts.hd.wallpaper.interfaces.UpdateListener;
import nemosofts.hd.wallpaper.utils.ApplicationUtil;
import okhttp3.RequestBody;

public class LoadUpdateTask extends AsyncTask<String, String, String> {

    private final RequestBody requestBody;
    private final UpdateListener listener;
    private String downloads = "", resolution= "", size= "", set= "", share= "";

    public LoadUpdateTask(UpdateListener listener, RequestBody requestBody) {
        this.listener = listener;
        this.requestBody = requestBody;
    }

    @Override
    protected void onPreExecute() {
        listener.onStart();
        super.onPreExecute();
    }

    @Override
    protected String doInBackground(String... strings) {
        try {
            String json = ApplicationUtil.responsePost(Callback.API_URL, requestBody);
            JSONObject mainJson = new JSONObject(json);
            JSONArray jsonArray = mainJson.getJSONArray(Callback.TAG_ROOT);
            for (int i = 0; i < jsonArray.length(); i++) {
                JSONObject objJson = jsonArray.getJSONObject(i);
                downloads = objJson.getString("total_download");
                resolution = objJson.getString("resolution");
                size = objJson.getString("size");
                set = objJson.getString("total_set");
                share = objJson.getString("total_share");
            }
            return "1";
        } catch (Exception e) {
            e.printStackTrace();
            return "0";
        }
    }

    @Override
    protected void onPostExecute(String s) {
        listener.onEnd(s, downloads, resolution, size, set, share);
        super.onPostExecute(s);
    }
}