package nemosofts.hd.wallpaper.asyncTask;

import android.os.AsyncTask;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;

import nemosofts.hd.wallpaper.callback.Callback;
import nemosofts.hd.wallpaper.interfaces.WallpaperListener;
import nemosofts.hd.wallpaper.item.ItemWallpaper;
import nemosofts.hd.wallpaper.utils.ApplicationUtil;
import okhttp3.RequestBody;

public class LoadWallpaper extends AsyncTask<String, String, String> {

    private final WallpaperListener listener;
    private final ArrayList<ItemWallpaper> arrayList = new ArrayList<>();
    private final RequestBody requestBody;
    private String verifyStatus = "0", message = "";

    public LoadWallpaper(WallpaperListener listener, RequestBody requestBody) {
        this.listener = listener;
        this.requestBody = requestBody;
    }

    @Override
    protected void onPreExecute() {
        listener.onStart();
        super.onPreExecute();
    }

    @Override
    protected  String doInBackground(String... strings)  {
        String json = ApplicationUtil.responsePost(Callback.API_URL, requestBody);
        try {
            JSONObject jOb = new JSONObject(json);
            JSONArray jsonArray = jOb.getJSONArray(Callback.TAG_ROOT);

            for (int i = 0; i < jsonArray.length(); i++) {
                JSONObject objJson = jsonArray.getJSONObject(i);

                if (!objJson.has(Callback.TAG_SUCCESS)) {

                    String id = objJson.getString("id");
                    String cid = objJson.getString("cat_id");
                    String cat_name = objJson.getString("category_name");
                    String img_name = objJson.getString("img_name");
                    String img = objJson.getString("wallpaper_image").replace(" ", "%20");
                    String total_views = objJson.getString("total_views");
                    String total_rate = objJson.getString("total_rate");
                    String rate_avg = objJson.getString("rate_avg");
                    boolean isPremium = objJson.getString("pay").equals("premium");
                    boolean isFav = objJson.getBoolean("is_favorite");
                    String img_type = objJson.getString("img_type");

                    ItemWallpaper itemWallpaper = new ItemWallpaper(id, cid, cat_name, img, total_views, total_rate, rate_avg, isPremium, "", isFav,img_type, img_name);
                    arrayList.add(itemWallpaper);

                } else {
                    verifyStatus = objJson.getString(Callback.TAG_SUCCESS);
                    message = objJson.getString(Callback.TAG_MSG);
                }
            }
            return "1";
        } catch (Exception e) {
            e.printStackTrace();
            return "0";
        }
    }

    @Override
    protected void onPostExecute(String s) {
        listener.onEnd(s, verifyStatus, message, arrayList);
        super.onPostExecute(s);
    }

}

