package nemosofts.hd.wallpaper.fragment.fav;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.core.content.ContextCompat;
import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentPagerAdapter;
import androidx.nemosofts.theme.ColorUtils;
import androidx.viewpager.widget.ViewPager;

import nemosofts.hd.wallpaper.R;
import nemosofts.hd.wallpaper.callback.Callback;
import nemosofts.hd.wallpaper.fragment.gif.FragmentLatestGIF;
import nemosofts.hd.wallpaper.fragment.online.FragmentFav;
import nemosofts.hd.wallpaper.utils.SharedPref;

public class FragmentFavourite extends Fragment {

    private TextView tv_wall, tv_gif;
    private int tab_no = 2;

    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        View rootView = inflater.inflate(R.layout.fragment_favourite, container, false);

        if(new SharedPref(getActivity()).isLogged()) {
            init(rootView);
        } else {
            rootView.findViewById(R.id.tv_fav_log).setVisibility(View.VISIBLE);
            rootView.findViewById(R.id.ll_fav).setVisibility(View.GONE);
        }

        setHasOptionsMenu(true);
        return rootView;
    }

    private void init(@NonNull View rootView) {
        if (Boolean.FALSE.equals(Callback.isGIFEnabled)) {
            tab_no = 1;
            rootView.findViewById(R.id.ll_fav).setVisibility(View.GONE);
        }

        SectionsPagerAdapter mSectionsPagerAdapter = new SectionsPagerAdapter(getChildFragmentManager());

        final ViewPager mViewPager = rootView.findViewById(R.id.container_fav);
        mViewPager.setAdapter(mSectionsPagerAdapter);
        mViewPager.setOffscreenPageLimit(3);

        tv_wall = rootView.findViewById(R.id.tv_tab_wall);
        tv_gif = rootView.findViewById(R.id.tv_tabs_gif);

        mViewPager.addOnPageChangeListener(new ViewPager.OnPageChangeListener() {
            @Override
            public void onPageScrolled(int position, float positionOffset, int positionOffsetPixels) {

            }

            @Override
            public void onPageSelected(int position) {
                setTabsBG(position);
            }

            @Override
            public void onPageScrollStateChanged(int state) {

            }
        });

        tv_wall.setOnClickListener(v -> {
            setTabsBG(0);
            mViewPager.setCurrentItem(0);
        });

        tv_gif.setOnClickListener(v -> {
            setTabsBG(1);
            mViewPager.setCurrentItem(1);
        });
    }

    public class SectionsPagerAdapter extends FragmentPagerAdapter {

        SectionsPagerAdapter(FragmentManager fm) {
            super(fm);
        }

        @NonNull
        @Override
        public Fragment getItem(int position) {
            if (position == 1) {
                return FragmentLatestGIF.newInstance(3);
            } else {
                return new FragmentFav();
            }
        }

        @Override
        public int getCount() {
            return tab_no;
        }
    }

    private void setTabsBG(int tabs) {
        if (tabs == 0) {
            tv_wall.setTextColor(ContextCompat.getColor(requireContext(), R.color.white));
            tv_gif.setTextColor(ColorUtils.colorAccent(requireContext()));

            tv_wall.setBackgroundResource(R.drawable.bg_tab_selected);
            tv_gif.setBackgroundResource(R.drawable.bg_tab_unselected);
        } else {
            tv_gif.setTextColor(ContextCompat.getColor(requireContext(), R.color.white));
            tv_wall.setTextColor(ColorUtils.colorAccent(requireContext()));

            tv_gif.setBackgroundResource(R.drawable.bg_tab_selected);
            tv_wall.setBackgroundResource(R.drawable.bg_tab_unselected);
        }
    }
}

